commit 350b3905b38b20faa1edba16449eb0efa15442ac
Author: freddy77 <freddy77>
Date:   Wed Oct 29 09:33:50 2008 +0000

    new functions to read and check db version

diff --git a/ChangeLog b/ChangeLog
index 85facd3..207552e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+Wed Oct 29 10:31:08 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/common.c src/odbc/unittests/common.h:
+	* src/odbc/unittests/cursor1.c src/odbc/unittests/data.c:
+	* src/odbc/unittests/genparams.c src/odbc/unittests/tables.c:
+	* src/odbc/unittests/utf8.c src/odbc/unittests/utf8_2.c:
+	- new function to read and check db version
+
 Wed Oct 29 09:41:42 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/convert.c: fix small memory read overflow
 
@@ -792,4 +799,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2642 2008/10/29 08:42:37 freddy77 Exp $
+$Id: ChangeLog,v 1.2643 2008/10/29 09:33:50 freddy77 Exp $
diff --git a/src/odbc/unittests/common.c b/src/odbc/unittests/common.c
index 82215d5..f9ae4bf 100644
--- a/src/odbc/unittests/common.c
+++ b/src/odbc/unittests/common.c
@@ -12,7 +12,7 @@
 #define TDS_SDIR_SEPARATOR "\\"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.46 2008/09/09 14:48:04 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.47 2008/10/29 09:33:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 HENV Environment;
@@ -308,6 +308,30 @@ driver_is_freetds(void)
 	return freetds_driver;
 }
 
+static char db_str_version[32];
+
+const char *db_version(void)
+{
+	SQLSMALLINT version_len;
+
+	if (!db_str_version[0])
+		CHK(SQLGetInfo, (Connection, SQL_DBMS_VER, db_str_version, sizeof(db_str_version), &version_len));
+
+	return db_str_version;
+}
+
+unsigned int db_version_int(void)
+{
+	unsigned int h, l;
+	if (sscanf(db_version(), "%u.%u.", &h, &l) != 2) {
+		fprintf(stderr, "Wrong db version: %s\n", db_version());
+		Disconnect();
+		exit(1);
+	}
+
+	return (h << 24) | ((l & 0xFFu) << 16);
+}
+
 void
 CheckCols(int n, int line, const char * file)
 {
diff --git a/src/odbc/unittests/common.h b/src/odbc/unittests/common.h
index 5e89ddf..bf4c174 100644
--- a/src/odbc/unittests/common.h
+++ b/src/odbc/unittests/common.h
@@ -21,7 +21,7 @@
 #include <sql.h>
 #include <sqlext.h>
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.23 2008/03/12 13:35:50 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.24 2008/10/29 09:33:50 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #ifndef HAVE_SQLLEN
@@ -68,6 +68,8 @@ int Disconnect(void);
 void Command(HSTMT stmt, const char *command);
 SQLRETURN CommandWithResult(HSTMT stmt, const char *command);
 int db_is_microsoft(void);
+const char *db_version(void);
+unsigned int db_version_int(void);
 int driver_is_freetds(void);
 
 #define int2ptr(i) ((void*)(((char*)0)+(i)))
diff --git a/src/odbc/unittests/cursor1.c b/src/odbc/unittests/cursor1.c
index 28e4609..39dc6dd 100644
--- a/src/odbc/unittests/cursor1.c
+++ b/src/odbc/unittests/cursor1.c
@@ -2,7 +2,7 @@
 
 /* Test cursors */
 
-static char software_version[] = "$Id: cursor1.c,v 1.13 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: cursor1.c,v 1.14 2008/10/29 09:33:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define CHK_INFO(func,params) \
@@ -195,13 +195,9 @@ Test(int use_sql)
 int
 main(int argc, char *argv[])
 {
-	char version[32];
-	SQLSMALLINT version_len;
-
 	Connect();
 
-	SQLGetInfo(Connection, SQL_DBMS_VER, version, sizeof(version), &version_len);
-	if (db_is_microsoft() && strncmp(version, "09.00.", 6) == 0)
+	if (db_is_microsoft() && db_version_int() >= 0x09000000u)
 		mssql2005 = 1;
 
 	Test(1);
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 7c06fea..8915107 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -13,7 +13,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: data.c,v 1.23 2008/10/24 14:03:04 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.24 2008/10/29 09:33:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -97,15 +97,11 @@ int
 main(int argc, char *argv[])
 {
 	int big_endian = 1;
-	char version[32];
-	SQLSMALLINT version_len;
 
 	Connect();
 
 	if (((char *) &big_endian)[0] == 1)
 		big_endian = 0;
-	memset(version, 0, sizeof(version));
-	SQLGetInfo(Connection, SQL_DBMS_VER, version, sizeof(version), &version_len);
 
 	Test("NUMERIC(18,2)", "123", SQL_C_NUMERIC, "38 0 1 7B");
 
@@ -130,8 +126,8 @@ main(int argc, char *argv[])
 	Test("TINYINT", "231", SQL_C_BINARY, "E7");
 	Test("SMALLINT", "4321", SQL_C_BINARY, big_endian ? "10E1" : "E110");
 	Test("INT", "1234567", SQL_C_BINARY, big_endian ? "0012D687" : "87D61200");
-	if ((db_is_microsoft() && (strncmp(version, "08.00.", 6) == 0 || strncmp(version, "09.00.", 6) == 0))
-	    || (!db_is_microsoft() && strncmp(version, "15.00.", 6) >= 0)) {
+	if ((db_is_microsoft() && db_version_int() >= 0x08000000u)
+	    || (!db_is_microsoft() && strncmp(db_version(), "15.00.", 6) >= 0)) {
 		int old_result = result;
 
 		Test("BIGINT", "123456789012345", SQL_C_BINARY, big_endian ? "00007048860DDF79" : "79DF0D8648700000");
@@ -145,7 +141,7 @@ main(int argc, char *argv[])
 	Test("INT", "-123", SQL_C_CHAR, "4 -123");
 	Test("INT", "78654", SQL_C_WCHAR, "5 78654");
 	Test("VARCHAR(10)", "  51245  ", SQL_C_LONG, "51245");
-	if (db_is_microsoft() && (strncmp(version, "08.00.", 6) == 0 || strncmp(version, "09.00.", 6) == 0)) {
+	if (db_is_microsoft() && (strncmp(db_version(), "08.00.", 6) == 0 || strncmp(db_version(), "09.00.", 6) == 0)) {
 		/* nvarchar without extended characters */
 		Test("NVARCHAR(20)", "test", SQL_C_CHAR, "4 test");
 		/* nvarchar with extended characters */
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 0a32c39..7f8c9b6 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -18,7 +18,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: genparams.c,v 1.35 2008/10/27 14:27:01 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.36 2008/10/29 09:33:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -211,7 +211,6 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 }
 
 static int big_endian = 1;
-static char version[32];
 
 static void
 AllTests(void)
@@ -309,7 +308,7 @@ AllTests(void)
 	TestOutput("VARCHAR(20)", "0xf8f9", SQL_C_CHAR, SQL_VARCHAR, "2 \xf8\xf9");
 
 	/* TODO some Sybase versions */
-	if (db_is_microsoft() && (strncmp(version, "08.00.", 6) == 0 || strncmp(version, "09.00.", 6) == 0)) {
+	if (db_is_microsoft() && db_version_int() >= 0x08000000u) {
 		TestOutput("BIGINT", "-987654321065432", SQL_C_BINARY, SQL_BIGINT, big_endian ? "FFFC7DBBCF083228" : "283208CFBB7DFCFF");
 		TestInput(SQL_C_SBIGINT, "BIGINT", SQL_BIGINT, "BIGINT", "-12345678901234");
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "test");
@@ -343,14 +342,9 @@ AllTests(void)
 int
 main(int argc, char *argv[])
 {
-	SQLSMALLINT version_len;
-
 	use_odbc_version3 = 1;
 	Connect();
 
-	memset(version, 0, sizeof(version));
-	SQLGetInfo(Connection, SQL_DBMS_VER, version, sizeof(version), &version_len);
-
 	if (((char *) &big_endian)[0] == 1)
 		big_endian = 0;
 
diff --git a/src/odbc/unittests/tables.c b/src/odbc/unittests/tables.c
index 671ef79..0f90c55 100644
--- a/src/odbc/unittests/tables.c
+++ b/src/odbc/unittests/tables.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: tables.c,v 1.14 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: tables.c,v 1.15 2008/10/29 09:33:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef WIN32
@@ -149,16 +149,13 @@ DoTest(const char *type, int row_returned)
 int
 main(int argc, char *argv[])
 {
-	char version[32];
 	char type[32];
-	SQLSMALLINT version_len;
 	int mssql2005 = 0;
 
 	use_odbc_version3 = 0;
 	Connect();
 
-	SQLGetInfo(Connection, SQL_DBMS_VER, version, sizeof(version), &version_len);
-	if (db_is_microsoft() && strncmp(version, "09.00.", 6) == 0) {
+	if (db_is_microsoft() && db_version_int() >= 0x09000000u) {
 		mssql2005 = 1;
 		strcpy(expected_type, "VIEW");
 		CommandWithResult(Statement, "USE master");
diff --git a/src/odbc/unittests/utf8.c b/src/odbc/unittests/utf8.c
index c353021..8b9a0f1 100755
--- a/src/odbc/unittests/utf8.c
+++ b/src/odbc/unittests/utf8.c
@@ -1,7 +1,7 @@
 #include "common.h"
 
 /* test binding with UTF-8 encoding */
-static char software_version[] = "$Id: utf8.c,v 1.4 2008/09/08 19:22:44 freddy77 Exp $";
+static char software_version[] = "$Id: utf8.c,v 1.5 2008/10/29 09:33:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -141,9 +141,7 @@ main(int argc, char *argv[])
 		return 0;
 	}
 
-        memset(tmp, 0, sizeof(tmp));
-        SQLGetInfo(Connection, SQL_DBMS_VER, tmp, sizeof(tmp), &len);
-	if (!db_is_microsoft() || (strncmp(tmp, "08.00.", 6) != 0 && strncmp(tmp, "09.00.", 6) != 0)) {
+	if (!db_is_microsoft() || db_version_int() >= 0x08000000u) {
 		Disconnect();
 		printf("Test for MSSQL only\n");
 		return 0;
diff --git a/src/odbc/unittests/utf8_2.c b/src/odbc/unittests/utf8_2.c
index 756445f..a275d07 100755
--- a/src/odbc/unittests/utf8_2.c
+++ b/src/odbc/unittests/utf8_2.c
@@ -1,7 +1,7 @@
 #include "common.h"
 
 /* test conversion of Hebrew characters (which have shift sequences) */
-static char software_version[] = "$Id: utf8_2.c,v 1.2 2008/10/15 14:53:00 freddy77 Exp $";
+static char software_version[] = "$Id: utf8_2.c,v 1.3 2008/10/29 09:33:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -67,9 +67,7 @@ main(int argc, char *argv[])
 		return 0;
 	}
 
-	memset(tmp, 0, sizeof(tmp));
-	SQLGetInfo(Connection, SQL_DBMS_VER, tmp, sizeof(tmp), &len);
-	if (!db_is_microsoft() || (strncmp(tmp, "08.00.", 6) != 0 && strncmp(tmp, "09.00.", 6) != 0)) {
+	if (!db_is_microsoft() || db_version_int() >= 0x08000000u) {
 		Disconnect();
 		printf("Test for MSSQL only\n");
 		return 0;

